<?php 

namespace Teknisa\DF\Modules\Entrada\Controllers;

/* Bibliotecas */
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

/* Classes DF */
use Teknisa\DF\Modules\Entrada\Services\Dfe71000SincronizacaoCTEService;

class Dfe71000SincronizacaoCTEController {
    
    protected $sincronizacaoCTEService;
    
    public function __construct(Dfe71000SincronizacaoCTEService $sincronizacaoCTEService) {
        $this->sincronizacaoCTEService = $sincronizacaoCTEService;
        set_time_limit(0);
    }
    
    public function montaConfigCte(Request\Filter $request, Response $response) {
        $requestConditions = $request->getFilterCriteria()->getConditions();
        $row = $requestConditions[0]["value"];
        
        try {
            $content = $this->sincronizacaoCTEService->montaConfigCte($row['CDEMPRESA'], $row['NRORG'], $row['CDINSCESTA'], $row["NRINSJURIEST"]);
            $response->addDataset(new DataSet('config_cte', ['config' => $content]));
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    }
    
    public function sincronizarCte(Request\Filter $request, Response $response){
        $requestConditions = $request->getFilterCriteria()->getConditions();
        $config = $requestConditions[0]["value"];
        $params = $requestConditions[1]["value"];
        
        try {
            $sincronizacao = $this->sincronizacaoCTEService->sincronizarCte($config, $params);
            $response->addDataset(new DataSet('sincronizarCte', [$sincronizacao]));
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}